C
Copyright Nobuhiro Fujita and H. K. D. H. Bhadeshia,
C University of Cambridge, 1998
C
C PROGRAM FOR SIMULTANEOUS TRANSFORMATIONS
C UP TO SIX PHASES AND THREE CONTROLLING SPECIES
C
C
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      DOUBLE PRECISION SFEN(4)
      DOUBLE PRECISION NAD(4),XB(1,4),XA(4,4)
      DOUBLE PRECISION XC(4,4),VMAX(4),VDIV(4)
      DOUBLE PRECISION GMOD(4,4),DV(4),TRT(200000)
      DOUBLE PRECISION DG(4),GRT(4),DVEXT(4)
      DOUBLE PRECISION VEQ(4),VES(4,200000),VE(4)
      DOUBLE PRECISION GROLD(4),DX(4),XAINSTR(4,200000)
      DOUBLE PRECISION RM(4),DGCHEM(4),CXBINST(4)
      DOUBLE PRECISION XBINST(4,4),C(4),GRCT(4,200000)
      DOUBLE PRECISION NP,XAINSTI(4,4),XAINSTG(4,4)
      DOUBLE PRECISION NR(4),SR(4,4),SRT(4),CXAR(200000)
      DOUBLE PRECISION DR,OGMOD(4,4),XCINST(4,4)
      DOUBLE PRECISION SZEX(4,200000),NPEX(4)
      DOUBLE PRECISION CC,CXA(4),CXB(4),CXC(4)
      DOUBLE PRECISION NRT(4,200000),NMEX(4,200000)
      DOUBLE PRECISION XAINST(1,4)
      INTEGER REG,DS(4),CTYPE(4)
      INTEGER FLG(4),CNT,N,Y
      PI = 3.141592654
      BETA = 15.0D0
      IN1 = 1
      OU2 = 2
      OU3 = 3

      OPEN(UNIT = IN1,FILE='MO2CMAP.d')
      OPEN(UNIT = OU2,FILE='junk.d')
      OPEN(UNIT = OU3,FILE='msize.d')
      OPEN(UNIT = OU4,FILE='tnch.d')
      OPEN(UNIT = OU5,FILE='vin.d')
C
C IPHASE - NUMBER OF PHASES TO CALCULATE FOR
C ISPEC - NUMBER OF RATE CONTROLLING DIFFUSING SPECIES
C
      IPHASE = 2
      ISPEC = 1
      WRITE(*,*)'IS 1st PHASE CEMENTITE? YSE=0, NO=1'
      READ(IN1,*) Y
      

      DO 20 I=1,IPHASE
        WRITE(*,*)'PHASE ',I
        WRITE(*,*)'INTERFACIAL ENERGY OF NUCLEUS (J/M^2) ?'
         READ(IN1,*) SFEN(I)
        WRITE(*,*)'SITE DENSITY (RELATIVE TO 1st Phase) ?'
         READ(IN1,*) NAD(I)
        WRITE(*,*)'PHASE TYPE (1 - NEEDLE, 2 - SPHERICAL) ?'
         READ(IN1,*) CTYPE(I)
        WRITE(*,*)'SPECIES CONTROLLING DIFFUSION (1,2,3...) ?'
         READ(IN1,*) DS(I)
        WRITE(*,*)'MAXIMUM VOLUME FRACTION ?'
         READ(IN1,*) VMAX(I)
        WRITE(*,*)'EQUILIBRIUM VOLUME FRACTION ?'
         READ(IN1,*) VEQ(I)
        WRITE(*,*)'DRIVING FORCE FOR FORMING VOLUME V OF PPT (J) ?'
         READ(IN1,*) DG(I)
        WRITE(*,*)'VOLUME FRACTION V (FOR DRIVING FORCE) ?'
         READ(IN1,*) VDIV(I)
C
C read concentrations (mole fraction)
C
        DO 25 II=1,ISPEC
          WRITE(*,*)'SPECIES', II
          WRITE(*,*)'MEAN CONCENTRATION IN ALLOY ?'
           READ(IN1,*) XB(II,I)
          WRITE(*,*)'EQUIM CONCENTRATION OF SPECIES IN PRECIPITATE ?'
           READ(IN1,*) XC(II,I)
          WRITE(*,*)'EQUIM CONCENTRATION OF SPECIES IN MATRIX ?'
           READ(IN1,*) XA(II,I)
          WRITE(*,*)'MEAN C CONCENTRATION IN ALLOY ?'
           READ(IN1,*) CXB(I)
          WRITE(*,*)'EQUIM C CONCENTRATION OF SPECIES IN PRECIPITATE ?'
           READ(IN1,*) CXC(I)
          WRITE(*,*)'EQUIM C CONCENTRATION OF SPECIES IN MATRIX ?'
           READ(IN1,*) CXA(I)
25     CONTINUE

20    CONTINUE
      WRITE(*,*)'Time step ?'
       READ(IN1,*) DT
      WRITE(*,*)'Absolute temperature ?'
       READ(IN1,*) TK
C
C------------------------------------------------------Cementite 
C This part if cementite is the first phase to form
C  necessary since it grows initially with paraequilibrium composition
C
      IF (Y.EQ.1) GOTO 10
      IF (Y .EQ. 0) THEN
       WRITE(*,*)'Carbon concentration in wt%'
        READ(IN1,*) CC
       WRITE(*,*)'Ratio of particles at boundary/intragranular?'
        READ(IN1,*) DR
       WRITE(*,*)'Grain boundary cementite thickness / m ?'
        READ(IN1,*) GTHI
       WRITE(*,*)'Intragranular cementite thickness / m?'
        READ(IN1,*) THI
C
C       calculate initial number density of cementite particles
C       equation is from Nobu's experimental measurements 

       NP = CC * 2.23d22 - 1.0d21
       NPL = DR * NP
       GBNP = (1-DR) * NP
     
      ENDIF

       VE(1) = VMAX(1)
       VL = VE(1) * DR * (THI)**(3.0D0) / (DR*(THI)**(3.0D0) +
     &      (1-DR)*(GTHI)**(3.0D0))

       VGB = VE(1) * (1-DR) * (GTHI)**(3.0D0) / (DR*(THI)**(3.0D0) +
     &      (1-DR)*(GTHI)**(3.0D0))


       XAINSTI(1,1)=XA(1,1)
       XAINSTG(1,1)=XA(1,1)

10     SRT(1) = 0.0D0
       ST = 0.0
       SR(1,2) = 0.0
       ONXCI=XB(1,1)  
       GBXCI=XB(1,1)
       FLG(1) = 0
    
      DO 11 I=1,IPHASE

       SR(1,I) = 0.0D0
       CXB(I) = CXBINST (I)

       XAINST(1,I)=XA(1,I)
       XBINST(1,I)=XB(1,I)
       XCINST(1,I)=XC(1,I)

c       IF (TK .EQ. 873) CXA(I) = 0.000283
c       IF (TK .EQ. 923) CXA(I) = 0.000493
c       IF (TK .EQ. 973) CXA(I) = 0.000822
c       IF (TK .EQ. 1023) CXA(I) = 0.001324

11    CONTINUE

C------------------------------------------------------Cementite complete


C Calculate diffusion coefficient D (m^2/s)

      CALL DIFCO(DCR,DC,TK)

C
C Set initial state of soft impingement
C

      DO 30 I=2,IPHASE
        GROLD(I) = 1.0D0
        OGMOD(1,I)=2.0D0
        FLG(I) = 0
30    CONTINUE

	WRITE(*,222)
222   FORMAT(5X,'   Time/s  ','    Vol.F.(Cem.) ', '  Mo2C Vol.F. ', 
     & '  Mo2C Max.Size/m ')

C Step time ************
      CNT = 0
      TINST = 0.0D0
40    J = J + 1.0D0
        T = (10.0D0**(J/10.0D0)) + DT
        REG = 1

50        TINST = TINST + DT
          N = TINST / DT
       CNT = CNT + 1

         IF (TINST .EQ. 1000000) THEN

          
          DO 45 JJ=1,CNT
           WRITE(OU3,47) SZEX(2,JJ),NMEX(2,JJ)
45        CONTINUE
          STOP
          ENDIF 
47      FORMAT(8D12.5)
C
C----------SR(1) solute 1 removed by reaction
C 
           SR(1,1) = VL*(ONXCI-XB(1,1))+VGB*(GBXCI-XB(1,1))

            
           SRT(1) = SR(1,1) + (XCINST(1,2)-XB(1,2))*VE(2)
C
C---------------------------------------------
C
           VT=VL+VGB+VE(2)

               DX(1)=SRT(1) / (1-VT) 

               GMOD(1,1) = 1.0D0 - DX(1)/(XB(1,1)-XA(1,1))

               XBINST(1,1) = XB(1,1)-DX(1)

          DO 60 I = 2,IPHASE
                
               DX(I)=SRT(1) / (1-VT) 

               XBINST(1,I) = XB(1,I)-DX(I)

               M=XBINST(1,I)-XAINST(1,I)
               SAT=M/(XCINST(1,I)-XAINST(1,I))

               GMOD(1,I)= 1- VE(I)/SAT


              IF (GMOD(1,I) .LE. 0.0 .OR. M .LE. 0.0) THEN
                 GMOD(1,I) = 0.0D0
              ENDIF

              DGCHEM(I) = GMOD(1,I)*DG(I)

60        CONTINUE

            IF (TK .EQ. 923) THEN

              CXBINST(2) = XBINST(1,2)*0.50544d+00-5.2690d-3
              IF (CXBINST(2) .lE. 0.000144d0) CXBINST(2)=0.000144d0
                  F =(-3.8447d-2 * DLOG10 (CXBINST(2)))

                  XCINST(1,2)= 0.50513 + F
                  XAINST(1,2)=2.2427d-4 + 3.7986d-7 / 
     &            CXBINST(2)-2.4115d-11*(1/CXBINST(2))**(2.0d0)


            ENDIF

            IF (TK .EQ. 973) THEN
           
                
              CXBINST(2) = -4.9781d-3+0.50878*XBINST(1,2)
              IF (CXBINST(2) .lE. 0.000364D+00) CXBINST(2)=0.000364D+00
                  H =(-4.5255D-2 * DLOG10 (CXBINST(2)))

                  XCINST(1,2)= 0.48398 + H
                  XAINST(1,2)=3.3467d-4 + 1.4191d-6 / 
     &            CXBINST(2)-4.7477d-10*(1/CXBINST(2))**(2.0d0)+
     &            7.9388d-14*(1/CXBINST(2))**(3.0d0)

            ENDIF

            IF (TK .EQ. 873) THEN
           
                
              CXBINST(2) = -5.4731d-3+0.50492*XBINST(1,2)
              IF (CXBINST(2) .lE. 0.000041D+00) CXBINST(2)=0.000041D+00

                  XCINST(1,2)=0.65648 - 34.44 * 
     &            CXBINST(2)+8503.0*(CXBINST(2))**(2.0d0)-
     &            8.1104d5*(CXBINST(2))**(3.0d0)
 
                  XAINST(1,2)=1.1301d-4 + 1.2248d-7 / 
     &            CXBINST(2)-4.7483d-12*(1/CXBINST(2))**(2.0d0)+
     &            7.5251d-17*(1/CXBINST(2))**(3.0d0)



            ENDIF

            IF (TK .EQ. 1023) THEN
           
                
              CXBINST(2) = -4.5589d-3+0.51604*XBINST(1,2)
              IF (CXBINST(2) .lE. 0.000753D+00) CXBINST(2)=0.000753D+00

                  XCINST(1,2)=0.64088 - 25.336 * 
     &            CXBINST(2)+4454.5*(CXBINST(2))**(2.0d0)-
     &            3.4644d5*(CXBINST(2))**(3.0d0)
 
                  XAINST(1,2)=5.8507d-4 + 3.3409d-6 / 
     &            CXBINST(2)-1.6445d-9*(1/CXBINST(2))**(2.0d0)+
     &            4.6268d-13*(1/CXBINST(2))**(3.0d0)
            ENDIF




63          DO 61 I = 2,IPHASE
              IF (XAINST(DS(I),I) .LE. 0.0 
     &        .OR. XCINST(DS(I),I) .LE. 0.0) THEN
              DGCHEM(I) = 0.0
               
                 
              ENDIF
                  
61        CONTINUE

                


C---------------------------------------------

C
C ENRICHMENT OR VOLUME DECREASE OF CEMENTITE
C
          IF (NPL .GT. 0.0) THEN
           RM(1) = (3.0D0 * VL)/((4.0D0 * NPL * PI))
     &           **(1.0D0/3.0D0)
          ELSE
           RM(1) = 0.0
          ENDIF

          IF (GBNP .GT. 0.0) THEN
           GBRM = (3.0D0 * VGB)/((4.0D0 * GBNP * PI))
     &           **(1.0D0/3.0D0)
          ELSE
           GBRM = 0.0
          ENDIF

           IF (ONXCI .LT. XC(1,1)) THEN
          
             DXCI = ((4.0D0 * (DCR**(0.5)) * (XBINST(1,1)
     &         -XAINSTI(1,1))* (DT**(0.5)))/(THI * (PI**(0.5))))
           ENDIF

           IF (GBXCI .LT. XC(1,1)) THEN
         
             GBDXCI = ((4.0D0 * (DCR**(0.5)) * (XBINST(1,1)
     &         -XAINSTG(1,1))* (DT**(0.5)))/(GTHI * (PI**(0.5))))
           ENDIF

             ONXCI = ONXCI + DXCI
             GBXCI = GBXCI + GBDXCI

 
 
C
C CEMENTITE DISSOLVES TO PROVIDE SOLUTE TO REMAINING PRECIPITATES
C DIFFUSION FROM CEMENTITE TO PRECIPITATES CONTROLS THE DISSOLUTION OF
C CEMENTITE
C
C
C THERE WILL ONLY BE A FLUX FROM CEMENTITE TO ANOTHER PHASE IF XA FOR
C THE CORRECT SPECIES IN THE PRECIPITATING PHASE IS LESS THAN
C XA FOR THE CORRECT SPECIES IN THE DISSOLVING PHASE
C

           IF (XBINST(1,1) .LT. XAINSTI(1,1)) THEN

                    VINCI = (DCR * (XAINSTI(1,1)
     &              - XBINST(1,1))+DC*(CXA(1)-CXA(1)))
     &              /(XCINST(1,1) - XAINSTI(1,1)+
     &              CXC(1)-CXA(1))*
     &              ((NPL + NPEX(2))
     &              **(1.0D0/3.0D0))
           ENDIF

           IF (XBINST(1,1) .LT. XAINSTG(1,1)) THEN
                    VINCG = (DCR * (XAINSTG(1,1)
     &              - XBINST(1,1))+DC*(CXA(1)-CXA(1)))
     &              /(XCINST(1,1) - XAINSTG(1,1)+
     &              CXC(1)-CXA(1))*
     &              ((GBNP + NPEX(2))
     &              **(1.0D0/3.0D0))
           ENDIF
                    
                    RM(1) = RM(1) - VINCI
                    GBRM = GBRM - VINCG

              IF (RM(1) .GT. 0.0d0) THEN

               DVFLUXI = (4.0D0 * PI / 3.0d0) * ((RM(1)**3.0D0)
     &         -(RM(1)-VINCI*DT)**3.0D0)
               
               ELSE
                RM(1) = 0.0D0
                NPL = 0.0D0
                VL = 0.0D0
                DVFULXI = 0.0D0
              ENDIF
               
              IF (GBRM .GT. 0.0d0) THEN

               DVFLUXG= (4.0D0 * PI / 3.0d0) * ((GBRM**3.0D0)
     &         -(GBRM-VINCI*DT)**3.0D0)

               ELSE
                GBRM = 0.0
                GBNP = 0.0
                VGB = 0.0D0
              ENDIF
              
              IF (DVFLUXI .LE. 0.0) DVFLUXI = 0.0
              IF (DVFLUXG .LE. 0.0) DVFLUXG = 0.0
 

               DV(1) = DV(1) + (NPL * DVFLUXI+
     &         GBNP * DVFLUXG)
               DVGB = DVGB + GBNP*DVFLUXG
               DVL = DVL + NPL*DVFLUXI

               NP = NPL + GBNP
               VE(1) = VL + VGB

70         CONTINUE

          DXCI =0.0D0
          GBDXCI =0.0D0
          VE(1) = VE(1) - DV(1)
          VGB = VGB - DVGB
          VL = VL - DVL
          IF (VE(1) .LT. 0.0D0) THEN
             VE(1) = 0.0D0
             DV(1) = 0.0D0
          ENDIF

          IF (VL.LT. 0.0D0) VL = 0.0D0
          IF (VGB.LT. 0.0D0) VGB = 0.0D0

C
C PRECIPITATION OR VOLUME DECREASE OF OTHER PHASES
C




         DO 80 I = 2,IPHASE
          IF (FLG(I) .EQ. 0) THEN
             IF (DGCHEM(I) .LT. 0.0D0) THEN
              CALL NURATE(NR(I),DGCHEM(I),SFEN(I),NAD(I),VDIV(I),TK,CC)
             ELSE
              NR(I) = 0.0D0
             ENDIF
C
C ONLY HAVE GROWTH IF COMPOSITION IS DIFFERENT FROM BULK COMPOSITION
C
           IF (XCINST(DS(I),I) .GT. XAINST(DS(I),I)) THEN

           IF (CTYPE(I) .EQ. 1) THEN
 
           OGRT=0.0D0
           DO 62 IJI=2, 10000
           TRT(IJI) = IJI*1D-10
           CCAP=SFEN(I) * 3.0d0**(0.5d0)/2.0d0*3.002d-10**(2.0d0)
     &     *4.724d-10 / TK/1.380662D-23
     &     *(1-CXA(I))/(CXC(I)-CXA(I))

           MCAP=SFEN(I) *  3.0d0**(0.5d0)/2.0d0*3.002d-10**(2.0d0)
     &     *4.724d-10 / TK/1.380662D-23
     &     *(1-XAINST(DS(I),I))/(XCINST(DS(I),I)-XAINST(DS(I),I))


           XAINSTr(DS(I),I)=(1+MCAP/TRT(IJI))*XAINST(DS(I),I)
           CXAR(I)=(1+CCAP/TRT(IJI))*CXBINST(I)

           IF (XAINSTR(DS(I),I) .LT. XBINST(DS(I),I)) THEN

               CALL GROWTH
     &         (GRT(I),CTYPE(I),XBINST(DS(I),I),XAINSTR(DS(I),I)
     &         ,XCINST(DS(I),I),
     &         DCR,TRT(IJI),DC,CXAR(I),CXBINST(I),CXC(I))
              IF (GRT(I) .GE. OGRT) THEN
              OGRT=GRT(I)
              ELSE
              GRT(I)=OGRT
              GOTO 71
              ENDIF
            ENDIF
62       CONTINUE

            ENDIF

             ELSE
               GRT(I) = 0.0D0
             ENDIF
            ELSE
             NR(I)=0.0
             GRT(I)=0.0
            ENDIF
           IF(XAINST(DS(I),I) .LE. 0.0 .OR.
     &     XCINST(DS(I),I) .LE. 0.0) THEN
              GRT(I)=0.0
           ENDIF  
71           CALL SIZE(RM(I),CTYPE(I),GRT(I),VE(I),NP,BETA)
             CALL CONST(C(I),CTYPE(I),GRT(I),BETA)

C
C FOR SIZE DISTRIBUTION OF PARTICLES NUCLEATING/ GROWING
C
C
C OVERALL KINETICS ROUTINE TO FIND DVEXT(I) 
C
             IF (FLG(I) .EQ. 0) THEN
               NMEX(I,CNT)=NR(I) * DT
               NRT(I,CNT)=NR(I)
               GRCT(I,CNT)=GRT(I)

                DO 88 IIJJ = 1,CNT
                 IF (CNT .LE. 0) SZEX(I,IIJJ) = 0.0

                 IF (IIJJ .LE. CNT) THEN
                  IF (CTYPE(I) .EQ. 2) THEN
                    SZEX(I,IIJJ)= SZEX(I,IIJJ) + 
     &              GRT(I) * (DT)**0.5 * ((CNT-IIJJ+1)**0.5
     &              - (CNT-IIJJ)**0.5)
                  ELSE
                    SZEX(I,IIJJ)=SZEX(I,IIJJ) + (GRT(I) * DT)
                  ENDIF
                 ENDIF
88              CONTINUE

                  VES(I,0) =0.0
                  VES(I,CNT) = 0.0D0
                  VE(I) = 0.0D0
                  NPEX(I)=0.0
 
                 DO 125  JJ=1,CNT
                  IF (SZEX(I,JJ) .GT. 0.0D0) THEN
                   IF (CTYPE(I) .EQ. 1) THEN
                   VES(I,CNT) = VES(I,CNT) + NMEX(I,JJ) * 
     &             PI *(SZEX(I,JJ))
     &             **3.0D0
     &             / 4.0D0 / ((BETA)**2.0D0)
                   ELSE
                   VES(I,CNT) = VES(I,CNT) + NMEX(I,JJ) * 
     &             4.0D0 * PI *
     &             (SZEX(I,JJ))**3.0D0 / 3.0D0
                    ENDIF
                  ELSE
                   SZEX(I,JJ)=0.0
                   NMEX(I,JJ)=0.0


                  ENDIF
                 NPEX(I) = NPEX(I) + NMEX(I,JJ)

125              CONTINUE

                IF (FLG(I) .EQ. 0) THEN
                 DVEXT(I) = VES(I,CNT)-VES(I,CNT-1)
                 SR(1,I) = VES(I,CNT)*(XCINST(1,I)-XB(1,I)) 
                 VE(I) = VES(I,CNT)
 
                ENDIF


               ENDIF                     



C
C DONT LET VF FALL BELOW EQUIM VALUE
C
C IF XC(DS(I),II) < XA(DS(I),II) THEN DVADD WILL BE PREDICTED -VE. IN REALITY
C THIS CORRESPONDS TO THE SITUATION WHERE DISSOLUTION OF ONE PHASE
C WILL NOT ENCOURAGE THE PRECPITATION OF PHASE II. IN THIS CASE SET
C DVADD TO ZERO
C
              IF (VE(I) .LE. 0.0D0) VE(I) = 0.0D0
               IF (FLG(I) .EQ. 1) THEN
                WRITE(*,*)'PRECIPITATION OF PHASE COMPLETE FOR PHASE ',I
                FLG(I) = 2
               ENDIF
80        CONTINUE
           


          REG = 0
          IF (FLG(1) .EQ. 1) THEN
             WRITE(*,*)'CEMENTITE ENRICHMENT COMPLETE!'
             FLG(1) = 2
          ENDIF
          IF (TINST .GE. T) THEN
            WRITE(*,200) TINST,VE(1),VE(2),SZEX(2,1)
          GOTO 40
          ELSE
                GOTO 50
          ENDIF


200	FORMAT(1X,4D15.5)
999   STOP
      END
C
C***********************************************************
C
C CALCULATES CONSTANT IN KINETICS EQUATION FOR CORRECT
C PARTICLE TYPE
C
      SUBROUTINE CONST(C,CTYPE,GRT,BETA)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      INTEGER CTYPE
      PI = 3.141592654
      IF (CTYPE .EQ. 1) THEN
          C = (3.0D0 * (GRT**3.0D0) * PI)/(4.0d0 * (BETA **2.0D0))
      ENDIF
      IF (CTYPE .EQ. 2) THEN
          C = (2.0D0) * PI * (GRT **3.0D0)
      ENDIF
      RETURN
      END
C
C***********************************************************
C
C CALLS SUBROUTINE FOR GROWTH DEPENDING ON PARTICLE TYPE
C
      SUBROUTINE GROWTH(GRT,CTYPE,XB,XA,XC,DCR,TRT,DC,CXA,CXB,CXC)
      INTEGER CTYPE
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      IF (CTYPE .EQ. 1) THEN
         CALL LINEARGROWTH (GRT,XB,XA,XC,DCR,TRT,DC,CXA,CXB,CXC)
      ENDIF
      IF (CTYPE .EQ. 2) THEN
         CALL PARABOLGROWTH(GRT,XB,XA,XC,DCR,DC,CXA,CXB,CXC)
      ENDIF
      RETURN
      END
C
C***********************************************************
C
C CALCULATES THE GROWTH RATE FOR LINEAR GROWTH (I.E. NEEDLES)
C
      SUBROUTINE LINEARGROWTH(GR,XB,XA,XC,DCR,TR,DC,CXA,CXB,CXC)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      OMEGA = (XB - XA)/(XC - XA)
      COMEGA = (CXB - CXA)/(CXC - CXA)
       GR =DCR *OMEGA*(XC-XA)/(TR)
     &      /((CXC-CXA)+(XC-XA))
     &      /(2*(XC-XB)/(XC-XA))
      RETURN
      END
C
C***********************************************************
C
C CALCULATES THE GROWTH CONSTANT (ALPHA3) FOR PARABOLLIC GROWTH
C
      SUBROUTINE PARABOLGROWTH(GC,XB,XA,XC,DCR,DC,CXA,CXB,CXC)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      OMEGA = (XB - XA)/(XC - XA)
      COMEGA = (CXB - CXA)/(CXC - CXA)
C
C 'NATURAL' GROWTH PARAMETER (P. 488 CHRISTIAN)
C

       GC = OMEGA*(((DC*(CXC-CXA)*COMEGA**(2.0d0)+
     &        DCR*(XC-XA)*OMEGA**(2.0d0))
     &       /((CXC-CXA)+(XC-XA)))/OMEGA**(2.0D0))**(0.5d0)
       


      RETURN
      END
C
C***********************************************************
C
C CALCULATES AVERAGE PARTICLE SIZES
C
      SUBROUTINE SIZE(RM,CTYPE,GRT,VE,NP,BETA)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      INTEGER CTYPE
      PI = 3.141592654
      IF ((VE .EQ. 0.0D0) .OR. (NP .EQ. 0.0D0)) THEN
         RM = 0.0D0
      ELSE
        IF (CTYPE .EQ. 1) THEN
          RM = (4.0d0 * ((BETA**2.0D0) * VE)/(PI * NP)) ** (1.0D0/3.0D0)
        ENDIF
        IF (CTYPE .EQ. 2) THEN
          RM =((3.0D0 * VE)/(4.0D0 * NP * PI)) ** (1.0D0/3.0D0)
        ENDIF
      ENDIF
      RETURN
      END
C
C***********************************************************
C
C CALCULATES NUCLEATION RATE
C
      SUBROUTINE NURATE(NR1,DGCHEM,SFEN1,NAD1,VMAX,TK,CC)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
       K = 1.380662D-23
       NA = 6.022045D23
       H = 6.626176D-34
       SHAPE=1.0D0
       DGVOL = (DGCHEM/VMAX) * 1.44D5
       ACTIVE = (240.0D3/2.0D0)/NA
       PI = 3.141592654
       NUSITES = CC * 2.23D22 - 1D21
       N1 = NAD1 * NUSITES
       DGCRIT1 = (16.0D0*PI*((SFEN1*SHAPE)**3.0D0))/
     &  (3.0D0*(DGVOL**2.0D0))
       EPENT1 = -(DGCRIT1 + ACTIVE)/(K * TK)
       CONST1 = (N1 * K * TK)/H
       NR1 = CONST1 * DEXP(EPENT1)
       RETURN
       END
C
C***********************************************************
C  CALCULATES DIFFUSION COEFFICIENT OF CR IN FE
C
      SUBROUTINE DIFCO(DCR,DC,TK)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
          D0CR = 1.1D-04
          D0C = 6.2D-03
          QCR = 240D03
          QC = 80D03
          R = 8.314408694
          DCR = D0CR * DEXP(-QCR/(R*TK))
          DC = D0C * DEXP(-QC/(R*TK))



      RETURN
      END
C
C***********************************************************
C
C  USER INPUT 
C
      SUBROUTINE USER(ISTENO,INSTEELS,TK,IN2)
      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      INTEGER ISTENO,INSTEELS
      CHARACTER*20 STEEL
      WRITE(*,*)'** SIMULTANEOUS TRANSFORMATIONS PROGRAM **'
      WRITE(*,*)
      WRITE(*,*)'DATA ARE AVAILABLE FOR THE FOLLOWING STEEL(S)'
      WRITE(*,*)
      READ(IN2,*) INSTEELS
      DO 5 IIS = 1,INSTEELS
         READ(IN2,51) STEEL
         WRITE(*,*) IIS,'-',STEEL
5     CONTINUE
51    FORMAT (A20)
      WRITE(*,*)
      WRITE(*,*)'SELECT STEEL TO USE FOR CALCULATIONS'
52      READ(IN1,*) ISTENO
      IF ((ISTENO .LT. 1) .OR. (ISTENO .GT. INSTEELS)) THEN
         WRITE(*,*)'**OUT OF RANGE, ENTER NEW STEEL NUMBER'
         GOTO 52
      ENDIF
53    WRITE(*,*)'WHAT TEMPERATURE FOR CALCULATIONS (500-800 degC) ?'
      READ(IN1,*) TC
      IF ((TC .LT. 500.0) .OR. (TC .GT. 800.0)) THEN
         WRITE(*,*)'**TEMPERATURE OUT OF RANGE, SELECT AN OPTION'
         WRITE(*,*)
         WRITE(*,*)'1-PROCEED, RESULTS LIKELY TO BE UNRELIABLE'
         WRITE(*,*)'2-ENTER A DIFFERENT TEMPERATURE'
         READ(IN1,*) IOPT
         IF (IOPT .NE. 1) GOTO 53
      ENDIF
      TK = TC + 273.0D0
      RETURN
      END
C
C***********************************************************
C
C  CALCULATES COMPOSITIONS/FREE ENERGIES FROM LINE FIT
C
      SUBROUTINE LINECALC(Y,M1,M2,C1,C2,TMAX,TK)

      IMPLICIT REAL*8(A-H,K-Z),INTEGER(I,J)
      IF (TK .GE. TMAX) THEN
         Y = (M2 * TK) + C2
      ELSE
         Y = (M1 * TK) + C1
      ENDIF
      RETURN
      END
